# Time-stamp: <2008-05-22 17:27:36 Tao Liu>

"""Module Description: Read raw data

"""

# ------------------------------------
# python modules
# ------------------------------------
import csv
from MA2C import CsvFilter

# ------------------------------------
# Misc functions
# ------------------------------------


def read(cyeFileNames):
    result = {}
    result["cye5"] = {}
    result["cye3"] = {}
    
    # cye5
    fileName = cyeFileNames["cye5File"]
    
    reader = csv.DictReader(CsvFilter.Filter(fileName), delimiter = '\t')
    store = result["cye5"]
    
    for row in reader:
        
        if not row.has_key("X"):
            raise IOError("X column does not exist in %s!" % fileName)
        
        if not row.has_key("Y"):
            raise IOError("Y column does not exist in %s!" % fileName)
        
        if not row.has_key("PM"):
            raise IOError("PM column does not exist in %s!" % fileName)
        
        x = int(row["X"])
        y = int(row["Y"])
        pm = row["PM"]
        
        key = (x, y)
        
        store[key] = pm
        
    del reader
        
    # cye3
    fileName = cyeFileNames["cye3File"]
    
    reader = csv.DictReader(CsvFilter.Filter(fileName), delimiter = '\t')
    store = result["cye3"]
    
    for row in reader:
        
        if not row.has_key("X"):
            raise IOError("X column does not exist in %s!" % fileName)
        
        if not row.has_key("Y"):
            raise IOError("Y column does not exist in %s!" % fileName)
        
        if not row.has_key("PM"):
            raise IOError("PM column does not exist in %s!" % fileName)
        
        x = int(row["X"])
        y = int(row["Y"])
        pm = row["PM"]
        
        key = (x, y)
        
        store[key] = pm
        
    del reader
    
    return result
        
