/*
 * Bed.java
 *
 * Created on 20061011, 12:32
 * Fixed on 1/10/2008, Tao Liu
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package MA2C;

import java.text.DecimalFormat;

/**
 *
 * @author zhuxp
 */

public class Bed {

    String Chr;
    long Start;
    long Stop;
    int PeakPos;
    int ProbeNumber;
    double Score;
    double Pvalue;
    double FDR;
    double MA2CScore;
    String ID;
    int negative_or_positive;//negative peaks or positive peaks
    int Strand;
    int len;
    int ProbeStart;
    int ProbeStop;

    /** Creates a new instance of Bed */
    public Bed() {
    }

    public Bed(String Chr, long Start, long Stop, double Score) {
        this.Chr = Chr;
        this.Start = Start;
        this.Stop = Stop;
        this.Score = Score;
    }

    public Bed(String bed) {
        String[] a = bed.split("\t");
        this.Chr = a[0];
        this.Start = Long.valueOf(a[1]);
        this.Stop = Long.valueOf(a[2]);
        this.ID = a[3];
        this.Score = Double.valueOf(a[4]);
    }

    public String toBEDString() {
        // Note: the position in BED format is 0-start, right-opened
        DecimalFormat myFormatter = new DecimalFormat("###.#####");
        len = (int) (Stop - Start+1); // Tao
        String str = Chr + "\t" + Long.toString(Start-1) + "\t" + Long.toString(Stop) + "\t" + ID + "\t" + myFormatter.format(Score);
        return str;
    }

    public String toGFFString() {
        // Note: the position in GFF format is 1-start, right-closed
        DecimalFormat myFormatter = new DecimalFormat("###.#####");
        len = (int) (Stop - Start+1); // Tao
        double P = -10 * Math.log10(Pvalue);
        String str = Chr + "\tNimbleScan\t" + "MA2C_Peak" + "\t" + Long.toString(Start) + "\t" + Long.toString(Stop)  + "\t" + myFormatter.format(Score) + "\t.\t.\tcutoff_p=" + myFormatter.format(P) + ";ID=" + ID;
        return str;
    }
    
    public String toXlsString() {
        DecimalFormat myFormatter = new DecimalFormat("###.#####");
        String str = Chr + "\t" + Long.toString(Start) + "\t" + Long.toString(Stop) + "\t" + ID + "\t" + myFormatter.format(Score);
        len = (int) (Stop - Start+1); // Tao
        double P = -10 * Math.log10(Pvalue);
        //str = str + "\t" + myFormatter.format(P) + "\t" + myFormatter.format(MA2CScore) + "\t";
        str = str + "\t" + myFormatter.format(P) + "\t";
        if (FDR < 100.0) {
            str = str + myFormatter.format(FDR);
        } else {
            str = str + "100";
        }
        str = str + "\t" + PeakPos + "\t" + len;
        //str = str + "\t" + PeakPos + "\t" + len + "\t" + ProbeNumber;
        return str;
    }
    
    // Use this function to duplicate a old Bed Object
    public void duplicate( Bed srcBed ) {
        this.Chr = srcBed.Chr;
        this.Start = srcBed.Start;
        this.Stop = srcBed.Stop;
        this.PeakPos = srcBed.PeakPos;
        this.Score = srcBed.Score;
        this.Pvalue = srcBed.Pvalue;
        this.FDR = srcBed.FDR;
        this.MA2CScore = srcBed.MA2CScore;
        this.ID = srcBed.ID;
        this.negative_or_positive = srcBed.negative_or_positive;
        this.Strand = srcBed.Strand;
        return;
    }
}
