/*
 * GraphFrame.java
 *
 * Created on August 1, 2006, 11:35 PM
 */

package MA2C;
import javax.swing.JPanel;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import org.jfree.chart.*;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.DateAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.time.Month;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYDataset;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.DefaultFontMapper;
import com.lowagie.text.pdf.FontMapper;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfTemplate;
import com.lowagie.text.pdf.PdfWriter;
import com.lowagie.text.Paragraph;
import org.jfree.data.general.DefaultPieDataset;
/**
 *
 * @author  jssong
 */
public class GraphFrame extends javax.swing.JFrame {
    
  
    JPanel[] chartPanels;
    String[] header;
    String currentTime = UtilityFunctions.getCurrentTime();
    int nChartPanels = 0;  // number of chart panels to be added to the JTabbedPanel
    /** Creates new form GraphFrame */
    String outpath = System.getProperty("user.home") +File.separator+currentTime;
    
    public GraphFrame(JPanel[] chartpanels, String outpath){
       
        this.chartPanels = chartpanels;
        this.nChartPanels = chartpanels.length;
        this.header = new String[nChartPanels];
        this.outpath = outpath;
        initComponents();
        setVisible(true);
    }
    public GraphFrame(JPanel[] chartpanels){
        this.chartPanels = chartpanels;
        this.nChartPanels = chartpanels.length;
        this.header = new String[nChartPanels];
        initComponents();
        setVisible(true);
    }
    public GraphFrame(JPanel[] chartpanels, String[] headerinfo, String outpath){
       
        this.chartPanels = chartpanels;
        this.nChartPanels = chartpanels.length;
        this.header = headerinfo;
        this.outpath = outpath;
        initComponents();
        setVisible(true);
    }
    public GraphFrame(JPanel[] chartpanels, String[] headerinfo){
       
        this.chartPanels = chartpanels;
        this.nChartPanels = chartpanels.length;
        this.header = headerinfo;
        initComponents();
        setVisible(true);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new JPanel();
        for(int k = 0; k < nChartPanels;k ++){
            jTabbedPane1.addTab(""+k, chartPanels[k]);
        }
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jPanel1.setBackground(new java.awt.Color(51, 204, 0));
        closeButton.setText("CLOSE");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        saveButton.setText("SAVE");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(135, 135, 135)
                .add(saveButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 121, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(121, 121, 121)
                .add(closeButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 115, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(157, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(closeButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(saveButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(24, 24, 24))
        );

        jPanel2.setBackground(new java.awt.Color(255, 0, 0));
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Courier", 1, 18));
        jTextArea1.setRows(5);
        jTextArea1.setText("The graphs were created by using JFreeChart.\n\nSave Button:  Save all images to a PDF file.");
        jScrollPane1.setViewportView(jTextArea1);

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 624, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 453, Short.MAX_VALUE)
                .addContainerGap())
        );
        jTabbedPane1.addTab("Help", jPanel2);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 649, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 500, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    public void setCurrentTime(String time){
        currentTime = time;
    }
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
// TODO add your handling code here:
        java.awt.Dimension dim = chartPanels[0].getPreferredSize();
        JFreeChart[] charts = new JFreeChart[nChartPanels];
        for (int k =0; k < nChartPanels; k ++){
            charts[k]= ((ChartPanel)chartPanels[k]).getChart();
        }
        
        try{
            setTitle(outpath);
            saveChartAsPDF(new File(outpath), 
                charts, (int) dim.getWidth(), (int) dim.getHeight(), header, new DefaultFontMapper());
        } catch (IOException e){
            
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    public void automaticSave(){
        
        java.awt.Dimension dim = chartPanels[0].getPreferredSize();
        JFreeChart[] charts = new JFreeChart[nChartPanels];
        for (int k =0; k < nChartPanels; k ++){
            charts[k]= ((ChartPanel)chartPanels[k]).getChart();
        }
        
        try{
            setTitle(outpath);
            saveChartAsPDF(new File(outpath), 
                charts, (int) dim.getWidth(), (int) dim.getHeight(), header, new DefaultFontMapper());
        } catch (IOException e){
            
        }
    }
    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
// TODO add your handling code here:
        dispose();
    }//GEN-LAST:event_closeButtonActionPerformed
     /**
* Saves a chart to a PDF file.
*
* @param file the file.
* @param chart the chart.
* @param width the chart width.
* @param height the chart height.
*/
public static void saveChartAsPDF(File file,
    JFreeChart[] chart,
    int width,
    int height,
    String[] header,
    FontMapper mapper) throws IOException {
        OutputStream out = new BufferedOutputStream(new FileOutputStream(file));
    writeChartAsPDF(out, chart, width, height, header, mapper);
    out.close();
}
/**
* Writes a chart to an output stream in PDF format.
*
* @param out the output stream.
* @param chart the chart.
* @param width the chart width.
* @param height the chart height.
*
*/
public static void writeChartAsPDF(OutputStream out,
    JFreeChart[] chart,
    int width,
    int height,
    String[] header,
    FontMapper mapper) throws IOException {
    
    Rectangle pagesize = new Rectangle(width, height+100);
    Document document = new Document(pagesize, 50, 50, 50, 50);
    try {
        PdfWriter writer = PdfWriter.getInstance(document, out);
        document.open();
        writer.setPageEmpty(true);
        
        for (int n = 0 ; n < chart.length; n ++){
            document.newPage();
            writer.setPageEmpty(false);
            document.add(new Paragraph(header[n]));
            PdfContentByte cb = writer.getDirectContent();
            PdfTemplate tp = cb.createTemplate(width, height);
            Graphics2D g2 = tp.createGraphics(width, height, mapper);
            Rectangle2D r2D = new Rectangle2D.Double(0, 0, width, height);
            chart[n].draw(g2, r2D);
            g2.dispose();
            cb.addTemplate(tp, 0, 0);
        }
    }
    catch (DocumentException de) {
    System.err.println(de.getMessage());
    }
    document.close();
}
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        DefaultPieDataset dataset = new DefaultPieDataset();
        dataset.setValue("Cat 1", 43.2);
        dataset.setValue("Cat 2", 30);
        dataset.setValue("Cat 3", 20);
        JFreeChart chart = ChartFactory.createPieChart(
                "Sample",
                dataset,
                true, true, false);
        
        ChartPanel[] cp = new ChartPanel[2];
        cp[0]= new ChartPanel(chart);
        cp[0].setPreferredSize(new java.awt.Dimension(500, 500));
        
        cp[1] = new ChartPanel(chart);
        cp[1].setPreferredSize(new java.awt.Dimension(500, 500));
        GraphFrame gf = new GraphFrame(cp);
        
        JFreeChart[] charts = new JFreeChart[2];
        charts[0] = chart;
        charts[1] = chart;
        File fileName = new File(System.getProperty("user.home") + "/jfreechart1.pdf");
        String[] header = new String[]{"Test Image 1", "Test Image 2"};
//        try{
//            GraphFrame.saveChartAsPDF( fileName, charts, 500,500,header, new DefaultFontMapper());
//        } catch(java.io.IOException e){
//            
//        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables
    
}
