/*
 * ControlPanel.java
 * GUI for NimbleGen analysis
 * Created on April 27, 2006, 12:23 PM
 * jssong   
 */

package MA2C;
import java.io.*;
import javax.swing.filechooser.FileFilter;
import java.util.Vector;
import java.util.Calendar;
import javax.swing.event.*;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableModel;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Enumeration;
/**
 *
 * @author  jssong
 */
public class NimbleControlPanel extends javax.swing.JFrame {
    File sampleFile = null;
    File seqDir = null;
    File dataDir = null;
    String previousDir = null;
    String configpath = null;
    final String PREFIX = "MA2C_";
    boolean sampleKeyFound = false;
    boolean seqDirFound = false;
    boolean pairDirFound = false;
    Vector allChIPDesignID = null;
    /** column indices of CHIP_ID and DESIGN_ID in SampleKey.txt **/
    int chipIDindex;
    int designIDindex;
    int dyeIndex;
    /** Creates new form ControlPanel */
    public NimbleControlPanel() {
        initComponents();
        jTabbedPane1.setEnabledAt(1, false);
        jTabbedPane1.setEnabledAt(2, false);
        jTabbedPane1.setEnabledAt(3, false);
    }
    /** Constructure when the configpath exists **/
    public NimbleControlPanel(String configpath){
        initComponents();
        this.configpath = configpath;
        jTabbedPane1.setEnabledAt(1, false);
        jTabbedPane1.setEnabledAt(2, false);
        jTabbedPane1.setEnabledAt(3, false);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jFileChooser1 = new javax.swing.JFileChooser();
        jFileChooser2 = new javax.swing.JFileChooser();
        jFileChooser3 = new javax.swing.JFileChooser();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        sampleKeyTable = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        exitButton = new javax.swing.JButton();
        pairDataButton = new javax.swing.JButton();
        seqFileButton = new javax.swing.JButton();
        sampleKeyButton = new javax.swing.JButton();
        runButton = new javax.swing.JButton();
        peakFinderButton = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jSeparator2 = new javax.swing.JSeparator();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        seqFileTable = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        pairDataTable = new javax.swing.JTable();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jLabel4 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jComboBox3 = new javax.swing.JComboBox();
        thresholdTextField = new javax.swing.JTextField();
        bandwidthTextField = new javax.swing.JTextField();
        outFileTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jBoxMA2CScore = new javax.swing.JComboBox();
        jLabel12 = new javax.swing.JLabel();
        minProbeTextField = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        maxGapTextField = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        replicateTable = new javax.swing.JTable();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTextArea5 = new javax.swing.JTextArea();

        jFileChooser2.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
        jFileChooser3.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("MA2C Model-based Analysis of 2 Color Arrays");
        setBackground(new java.awt.Color(255, 255, 204));
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setForeground(new java.awt.Color(255, 255, 204));
        setResizable(false);
        jPanel2.setBackground(new java.awt.Color(0, 153, 0));
        jScrollPane1.setAutoscrolls(true);
        sampleKeyTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        sampleKeyTable.setMinimumSize(new java.awt.Dimension(700, 64));
        jScrollPane1.setViewportView(sampleKeyTable);

        jPanel1.setBackground(new java.awt.Color(255, 51, 51));
        exitButton.setText("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        pairDataButton.setText("Pair Data");
        pairDataButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pairDataButtonActionPerformed(evt);
            }
        });

        seqFileButton.setText("Sequence");
        seqFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                seqFileButtonActionPerformed(evt);
            }
        });

        sampleKeyButton.setText("SampleKey");
        sampleKeyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sampleKeyButtonActionPerformed(evt);
            }
        });

        runButton.setText("Normalize");
        runButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runButtonActionPerformed(evt);
            }
        });

        peakFinderButton.setText("Find Peaks");
        peakFinderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                peakFinderButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, pairDataButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, seqFileButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, sampleKeyButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                    .add(exitButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, peakFinderButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, runButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(sampleKeyButton)
                .add(3, 3, 3)
                .add(seqFileButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(pairDataButton)
                .add(29, 29, 29)
                .add(runButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(peakFinderButton)
                .add(28, 28, 28)
                .add(exitButton)
                .addContainerGap(64, Short.MAX_VALUE))
        );

        jLabel1.setBackground(new java.awt.Color(51, 51, 51));
        jLabel1.setFont(new java.awt.Font("Times New Roman", 1, 14));
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setLabelFor(sampleKeyTable);
        jLabel1.setText("SampleKey");
        jLabel1.setOpaque(true);

        jScrollPane4.setAutoscrolls(true);
        jScrollPane4.setFont(new java.awt.Font("Times New Roman", 1, 12));
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Times New Roman", 1, 12));
        jTextArea1.setRows(5);
        jTextArea1.setTabSize(4);
        jScrollPane4.setViewportView(jTextArea1);

        jScrollPane6.setAutoscrolls(true);
        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Times New Roman", 1, 14));
        jTextArea2.setRows(5);
        jTextArea2.setText("                       WELCOME!\n- Please start by choosing a SampleKey file.\n");
        jScrollPane6.setViewportView(jTextArea2);

        jTabbedPane1.setName("");
        jScrollPane2.setAutoscrolls(true);
        seqFileTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null},
                {null},
                {null},
                {null}
            },
            new String [] {
                ".ndf Probe Sequence Files"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(seqFileTable);

        jScrollPane3.setAutoscrolls(true);
        pairDataTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null},
                {null},
                {null},
                {null}
            },
            new String [] {
                ".txt Pair Data Files"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane3.setViewportView(pairDataTable);

        jLabel2.setBackground(new java.awt.Color(0, 0, 0));
        jLabel2.setFont(new java.awt.Font("Times New Roman", 1, 14));
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setLabelFor(seqFileTable);
        jLabel2.setText("Sequece File");
        jLabel2.setOpaque(true);

        jLabel3.setBackground(new java.awt.Color(0, 0, 0));
        jLabel3.setFont(new java.awt.Font("Times New Roman", 1, 14));
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel3.setLabelFor(pairDataTable);
        jLabel3.setText("Pair Data");
        jLabel3.setOpaque(true);

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane2, 0, 0, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 312, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 428, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 428, Short.MAX_VALUE)))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 233, Short.MAX_VALUE)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 233, Short.MAX_VALUE)))
        );
        jTabbedPane1.addTab("File Info", jPanel3);

        jTextArea3.setColumns(20);
        jTextArea3.setRows(5);
        jTextArea3.setText("Method:\n   Two options are available for \n   computing the mean and variance \n   of probe intensities\n\n   - Simple: standard sample mean and variance\n   - Robust:\n\nC:\n   Parameter for the Robust option.\n   The larger the value of C, the closer \n   the estimates are to the Simple method.");
        jScrollPane5.setViewportView(jTextArea3);

        jLabel4.setBackground(new java.awt.Color(0, 0, 0));
        jLabel4.setForeground(new java.awt.Color(255, 255, 255));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setLabelFor(jComboBox1);
        jLabel4.setText("Method");
        jLabel4.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel4.setOpaque(true);

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Robust", "Simple" }));

        jLabel5.setBackground(new java.awt.Color(0, 0, 0));
        jLabel5.setForeground(new java.awt.Color(255, 255, 255));
        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setLabelFor(jComboBox2);
        jLabel5.setText("C");
        jLabel5.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel5.setOpaque(true);

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5" }));
        jComboBox2.setSelectedIndex(1);

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .add(jScrollPane5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 395, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(40, 40, 40)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jLabel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 87, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jComboBox2, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jComboBox1, 0, 161, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
            .add(jPanel4Layout.createSequentialGroup()
                .add(73, 73, 73)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(66, 66, 66)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jComboBox2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(81, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Normalization", jPanel4);

        jTextArea4.setColumns(20);
        jTextArea4.setRows(5);
        jTextArea4.setText("*Method:  criterion used for detecting \n   ChIP-enriched regions.\n*Threshold: cutoff score used in the method.\n   For a 5% FDR, put 0.05.\n*Bandwidth (in basepairs): half-width of the sliding window\n*Min #Probes: minimum number of probes required \n   in the sliding window centered at each probe; \n   a probe having fewer probes than this required \n   number in its window will be ignored in the analysis.\n*Max Gap  (in basepairs): maximum distance allowed \n   for joining two qualifying probes. \n*Output File Name: By default, all output \n   file names will be based on CHIP_IDs.\n   For replicate or single array runs,\n   the user can choose a basename.  Leave\n   this field blank for multiple single array \n   runs.\n\nN.B. Only one set of replicates can be run \nat a time.");
        jScrollPane7.setViewportView(jTextArea4);

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "P-value", "FDR", "MA2C" }));

        thresholdTextField.setText("1E-3");

        bandwidthTextField.setText("500");

        jLabel6.setBackground(new java.awt.Color(0, 0, 0));
        jLabel6.setForeground(new java.awt.Color(255, 255, 255));
        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setText("Method");
        jLabel6.setOpaque(true);

        jLabel7.setBackground(new java.awt.Color(0, 0, 0));
        jLabel7.setForeground(new java.awt.Color(255, 255, 255));
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText("Threshold");
        jLabel7.setOpaque(true);

        jLabel8.setBackground(new java.awt.Color(0, 0, 0));
        jLabel8.setForeground(new java.awt.Color(255, 255, 255));
        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setText("Bandwidth");
        jLabel8.setOpaque(true);

        jLabel9.setBackground(new java.awt.Color(0, 0, 0));
        jLabel9.setForeground(new java.awt.Color(255, 255, 255));
        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel9.setText("Output File Name");
        jLabel9.setOpaque(true);

        jRadioButton1.setText("Yes");
        jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        jLabel10.setBackground(new java.awt.Color(0, 0, 0));
        jLabel10.setForeground(new java.awt.Color(255, 255, 255));
        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel10.setText("Replicates?");
        jLabel10.setOpaque(true);

        jLabel11.setBackground(new java.awt.Color(0, 0, 0));
        jLabel11.setForeground(new java.awt.Color(255, 255, 255));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel11.setText("MA2C Score");
        jLabel11.setOpaque(true);

        jBoxMA2CScore.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Median", "PseudoMedian", "TrimmedMean", "MedianPolish" }));

        jLabel12.setBackground(new java.awt.Color(0, 0, 0));
        jLabel12.setForeground(new java.awt.Color(255, 255, 255));
        jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel12.setText("Min #Probes");
        jLabel12.setOpaque(true);

        minProbeTextField.setText("5");

        jLabel13.setBackground(new java.awt.Color(0, 0, 0));
        jLabel13.setForeground(new java.awt.Color(255, 255, 255));
        jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel13.setText("Max Gap");
        jLabel13.setOpaque(true);

        maxGapTextField.setText("250");

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(jScrollPane7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 379, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(jLabel9, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jLabel13, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jLabel11, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE))
                    .add(jLabel12, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                    .add(jLabel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                    .add(jLabel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                    .add(jLabel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                    .add(jLabel10, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE))
                .add(10, 10, 10)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(outFileTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, maxGapTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                        .add(jRadioButton1))
                    .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, thresholdTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, bandwidthTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                        .add(minProbeTextField)
                        .add(jBoxMA2CScore, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 184, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jComboBox3, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .add(317, 317, 317))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jBoxMA2CScore, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jComboBox3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(16, 16, 16)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(thresholdTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(14, 14, 14)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(bandwidthTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(minProbeTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(11, 11, 11)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(maxGapTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(8, 8, 8)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(outFileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(22, 22, 22)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jRadioButton1)
                    .add(jLabel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(19, Short.MAX_VALUE))
            .add(jScrollPane7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
        );
        jTabbedPane1.addTab("Peak Detection", jPanel5);

        jPanel6.setEnabled(false);
        jPanel6.setFocusable(false);
        replicateTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        replicateTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
        jScrollPane8.setViewportView(replicateTable);

        jTextArea5.setColumns(20);
        jTextArea5.setEditable(false);
        jTextArea5.setRows(5);
        jTextArea5.setText("Ctr-Click to select the replicates\nto be analyzed.\n\nTo start afresh, go back to the\n\"Peak Detection\" panel and click \non the \"Replicates\" button again.");
        jScrollPane9.setViewportView(jTextArea5);

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel6Layout.createSequentialGroup()
                .add(jScrollPane9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 310, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 95, Short.MAX_VALUE)
                .add(jScrollPane8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 341, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
            .add(jScrollPane9, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
        );
        jTabbedPane1.addTab("Replicates", jPanel6);

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 906, Short.MAX_VALUE)
                    .add(jSeparator2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 906, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 906, Short.MAX_VALUE)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 751, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 906, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2Layout.createSequentialGroup()
                        .add(jScrollPane6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 306, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 594, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 229, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 289, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE)
                    .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Check that all replicates have the same DESIGN_ID
    private String checkReplicateDesigns(String[] ChIP){
        String designID = "";
        for (int i = 0; i < ChIP.length; i ++){
                String tmpDesignID = "";
            for (int j = 0; j < allChIPDesignID.size(); j ++){
                String[] IDinfo = (String[]) allChIPDesignID.elementAt(j);  // IDinfo[0] = CHIP_ID; IDinfo[1] = DESIGN_ID
                if (IDinfo[0].equals(ChIP[i])){
                    tmpDesignID = IDinfo[1];
                    break;
                }
            }
            if (designID.equals("")){
                    designID = tmpDesignID;
            } else if (!designID.equals(tmpDesignID)){
                    return null;
            }
        }
        return designID;
    }
    private void peakFinderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_peakFinderButtonActionPerformed
        if(dataDir == null || sampleFile == null || dataDir == null) return;
        else{
            Thread loadingThread = new Thread() {
                public void run() {

                    String ScoreMethod = (String) jBoxMA2CScore.getSelectedItem();
                    String method = (String) jComboBox3.getSelectedItem();
                    if (method.equals("P-value")) method = "Pvalue";

                    double threshold = Double.parseDouble(thresholdTextField.getText());
                    if (method.equals("FDR")) threshold = threshold*100.0;
                    int bandwidth = Integer.parseInt(bandwidthTextField.getText());
                    int maxGap = Integer.parseInt(maxGapTextField.getText());
                    int minProbe = Integer.parseInt(minProbeTextField.getText());
                    // if analyzing replicates
                    if (jRadioButton1.isSelected()){
                        jRadioButton1.setSelected(false);
                        jTabbedPane1.setSelectedIndex(2);
                        jTabbedPane1.setEnabledAt(3,false);
                        int[] selectedRows = replicateTable.getSelectedRows();
                        int L = selectedRows.length;
                        String[] CHIP_IDs = new String[L];
                        String outfilename = "MA2C";

                        for(int i = 0; i < L; i ++){
                            CHIP_IDs[i] = (String) replicateTable.getValueAt(selectedRows[i],0);
                            outfilename += "_"+CHIP_IDs[i];
                        }

                        String DESIGN_ID = checkReplicateDesigns(CHIP_IDs);
                        if (DESIGN_ID == null){
                            updateTextArea("*** ERROR: THE CHOSEN SAMPLES HAVE DIFFERENT DESIGN_ID");
                            return;
                        }
                        updateTextArea("\nUsing method " + method);
                        updateTextArea("Using threshold " +  threshold);
                        updateTextArea("Using bandwidth " +  bandwidth);
                        updateTextArea("Using max gap " +  maxGap);
                        updateTextArea("Using min #probes  " +  minProbe);
                        /**  get tpmap file and check that it exists **/
                        String tpmap = seqDir.getAbsolutePath() + File.separator +"MA2C_"+DESIGN_ID+".tpmap";
                        if(! (new File(tpmap).exists())){
                            updateTextArea("*** ERROR: MISSING " + tpmap);
                        }
                        String[] ratio_fns = new String[L];
                        String dataPath = dataDir.getAbsolutePath() + File.separator +"MA2C_";
                        for(int i = 0; i < L; i ++){
                            /** get normalized data file and check that it exists **/
                            ratio_fns[i] = dataPath + CHIP_IDs[i] + "_normalized.txt";
                            if(! (new File(ratio_fns[i]).exists())){
                                updateTextArea("*** ERROR: MISSING " + ratio_fns[i]);
                            }
                        }
                        if (outFileTextField.getText().trim().length()>0) outfilename = outFileTextField.getText().trim();
                        // if corresponding normalized files are present, then find peaks; otherwise just return
                        if(checkNormalizedDataFiles(CHIP_IDs)){
                            updateTextArea("Finding ChIP-enriched regions for "+outfilename);
                            findPeaks(tpmap, ratio_fns,outfilename, method, bandwidth, maxGap, minProbe, threshold,ScoreMethod);        
                        } else return;
                        
                    } 
                    else{ // no replicates
                        updateTextArea("\nUsing method = " + method);
                        updateTextArea("Using threshold = " +  threshold);
                        updateTextArea("Using bandwidth = " +  bandwidth);
                        updateTextArea("Using max gap = " +  maxGap);
                        updateTextArea("Using min #probes = " +  minProbe);
                        if(sampleKeyTable.getSelectedRowCount() == 0){
                            updateTextArea("*** ERROR: SELECT SAMPLES");
                            return;
                        }
                        int samplesRows[] = sampleKeyTable.getSelectedRows();
                        final int nSamples = samplesRows.length;
                        
                        String[] CHIP_IDs = getChosenChIPIDs(samplesRows);
                        int L = CHIP_IDs.length;
                       
                        if(checkNormalizedDataFiles(CHIP_IDs)){
                            for(int i =0; i < L; i ++){
                                String DESIGN_ID = checkReplicateDesigns(new String[]{CHIP_IDs[i]});
                                if (DESIGN_ID == null){
                                    updateTextArea("*** ERROR: THE CHOSEN SAMPLES HAVE DIFFERENT DESIGN_ID");
                                    return;
                                }
                                String tpmap = seqDir.getAbsolutePath() + File.separator +"MA2C_"+DESIGN_ID+".tpmap";
                                /**  get tpmap file and check that it exists **/
                                if(! (new File(tpmap).exists())){
                                 updateTextArea("*** ERROR: MISSING " + tpmap);
                                }
                                String[] ratio_fns = new String[1];
                                String dataPath = dataDir.getAbsolutePath() + File.separator +"MA2C_";
                                ratio_fns[0] = dataPath + CHIP_IDs[i] + "_normalized.txt";

                                /** get normalized data file and check that it exists **/
                                if(! (new File(ratio_fns[0]).exists())){
                                    updateTextArea("*** ERROR: MISSING " + ratio_fns[0]);
                                }
                                String outfilename = "MA2C_" + CHIP_IDs[i];
                                if (L == 1 && outFileTextField.getText().trim().length()>0) outfilename = outFileTextField.getText().trim();
                                updateTextArea("Finding ChIP-enriched regions for "+outfilename);
                                findPeaks(tpmap, ratio_fns,outfilename, method, bandwidth, maxGap, minProbe,threshold,ScoreMethod);  


                            }
                        } else return;
                    }

                } // end of run()
            }; // end of thread
            loadingThread.start();
        }// end of first else
    }//GEN-LAST:event_peakFinderButtonActionPerformed
    
    private boolean checkNormalizedDataFiles(String[] CHIP_IDs){
       final String datapath =  dataDir.getAbsolutePath()+File.separator;
       boolean foundAll = true;
       int L = CHIP_IDs.length;
       for (int i=0; i < L; i ++){
           String filename = "MA2C_"+CHIP_IDs[i]+"_normalized.txt";
           if (! (new File(datapath+filename).exists())){
               updateTextArea("*** ERROR: " +filename + " NOT FOUND; NORMALIZE DATA FIRST");
               foundAll = false;
           }
       }
       return foundAll;
    }
    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        if (jRadioButton1.isSelected()){
            // if samples are not chosen for peak detection, then display all samples in the
            // replicate table
            if (sampleKeyTable.getSelectedRowCount() == 0) {
                jTabbedPane1.setEnabledAt(3,true);
                setDefaultReplicateTable();
            }
            
            // else display unique samples chosen
            else{
                int samplesRows[] = sampleKeyTable.getSelectedRows();
                
                // Check whether the chosen samples are unique
                if (checkUniqueSamples(samplesRows)){
                    updateTextArea("*** ERROR:  PLEASE CHOOSE UNIQUE SAMPLES.");
                    jRadioButton1.setSelected(false);
                    return;
                // CHIP_IDs are unique.  Display them on ReplicateTable.
                } else{
                    jTabbedPane1.setEnabledAt(3,true);
                    setChosenReplicateTable();
                }
            }
            jTabbedPane1.setSelectedIndex(3);
        }else{
            jTabbedPane1.setEnabledAt(3,false);
        }
    }//GEN-LAST:event_jRadioButton1ActionPerformed

    // Set the ReplicateTable using selected CHIP_IDs
    private void setChosenReplicateTable(){
        int samplesRows[] = sampleKeyTable.getSelectedRows();
        final int nSamples = samplesRows.length;
        String[] CHIP_IDs = getChosenChIPIDs(samplesRows);
        Object[][] tablecontent;

        tablecontent = new Object[nSamples][2];
        for (int i = 0; i < nSamples;i++) {
            String DESIGN_ID = checkReplicateDesigns(new String[]{CHIP_IDs[i]});
            tablecontent[i][0] = CHIP_IDs[i];
            tablecontent[i][1] = DESIGN_ID;
        }
        replicateTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
        new String[]{"CHIP_ID", "DESIGN_ID"}){
            boolean[] canEdit = new boolean[2];
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }                
        });
            replicateTable.selectAll();
        
    }
    // Set the ReplicateTable using all CHIP_IDs
    private void setDefaultReplicateTable(){
        
        final int L = allChIPDesignID.size();
        Object[][] tablecontent;
        tablecontent = new Object[L][2];
       
        for (int i = 0; i < L;i++) {
            
            tablecontent[i] = ((String[]) allChIPDesignID.elementAt(i));
             
        }
        replicateTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
        new String []{"CHIP_ID", "DESIGN_ID"}){
            boolean[] canEdit = new boolean[2];
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }                
        });
        

    }
    private void runButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runButtonActionPerformed
        if (seqDir == null || dataDir == null) return; 
        
        final String seqpath = seqDir.getAbsolutePath();
        final String datapath =  dataDir.getAbsolutePath();
        // Get the names of selected sequence and data files.
        final int samplesRows[] = sampleKeyTable.getSelectedRows();
        
        //sampleKeyTable.getValueAt(samplesRows[0], 2);
        
        /** Check that the user has selected unique IPs **/
        if (checkUniqueSamples(samplesRows)){
            return;
        }
        else {
            Thread loadingThread = new Thread() {
                public void run() {
                    
                    Vector fileinfo = checkSeqFiles(samplesRows); // get sequence file names for each IP
                    if (fileinfo.size() == 0) return;             // Not all IPs had a sequence file; abort
                    else{
                        if (checkPairDataFiles(fileinfo)){
                            //readSequences(fileinfo);             // Get pair data file names for each IP
                            
                            try{
                                File  seq = new File(seqpath);
                                File data = new File(datapath);
                                String currentTime = UtilityFunctions.getCurrentTime();
                                String parentDir = sampleFile.getParent() + File.separator;
                                
                                 /**  Create a new directory called MA2C for output **/
                                File outdir = new File(parentDir+"MA2C_Output");
                                String outpath=parentDir;
                                if( !outdir.exists()) {
                                    boolean dirCreated = outdir.mkdir();
                                    if (! dirCreated){
                                        updateTextArea("*** ERROR: FAILED TO CREATE "+ parentDir+"MA2C_Output");
                                        return;
                                    } else outpath = parentDir+"MA2C_Output"+ File.separator;
                                } else if (outdir.isDirectory()) outpath = parentDir+"MA2C_Output"+ File.separator;

                                
                                String logfile = outpath+"MA2C_"+ currentTime+".log";
                                FileWriter fout = new FileWriter(new File(logfile));
                                ArrayList<String> designIDlist = new ArrayList<String>(5);
                                String[][] pairInfo = new String[fileinfo.size()][4];  // CHIP_ID, IP Dye, Input Dye, DESIGN_ID
                               
                                fout.write("Sequence Directory:  " +  seqpath+"\n");
                                fout.write("Pair Data Directory:  " + datapath+"\n");
                                updateTextArea("\nCHIP_ID\tIP_DYE\tINPUT_DYE\tDESIGN_ID", fout);
                                // Turn fileinfo Vector into String[][]
                                for (int n = 0; n < fileinfo.size(); n ++){
                                    String[] info = (String[]) fileinfo.elementAt(n);  // ChIP_ID, Dye, DESIGN_ID
                                    
                                    pairInfo[n][0] = info[0];
                                    if (info[1].toUpperCase().equals("CY5")) {
                                        pairInfo[n][1] = "635"; pairInfo[n][2] = "532";
                                    }
                                    else {
                                        pairInfo[n][1] = "532"; pairInfo[n][2] = "635";
                                    }
                                    pairInfo[n][3] = info[2];
                                    if (!designIDlist.contains(info[2])) designIDlist.add(info[2]);
                                    updateTextArea(pairInfo[n][0] + "\t" + pairInfo[n][1] + "\t"+pairInfo[n][2] + "\t"+pairInfo[n][3], fout);
                                }
                                
                                
                                String[] design = designIDlist.toArray(new String[designIDlist.size()]);                               
                                FileChecker fc = new FileChecker(seq, data, design, pairInfo, fout);
                                updateTextArea("\nBuilding Sequence Files ... ", fout);
                                updateTextArea(fc.checkSeq());
                                 // Build GC count tables for probes
                                updateTextArea("\nBuilding GC Count Tables for Probes ... ", fout);
                                Hashtable GCTables = new Hashtable();
                                for (int n = 0; n < design.length; n++){
                                    GC_Enumerator GC = new GC_Enumerator(seqpath+File.separator + PREFIX + design[n] +".tpmap");
                                    GCTables.put(design[n], GC.GCTable);
                                }
                                
                                updateTextArea("\nCombining Pair Data Files ... ", fout);
                                updateTextArea(fc.checkRawData());
                                
                                // Normalize Data
                                double[][] array =  new double[ pairInfo.length][];
                                String[] graphInfo = new String[pairInfo.length];
                                String additionalInfo = "";
                                if (jComboBox1.getSelectedIndex() == 0){
                                    int level = jComboBox2.getSelectedIndex()+1;
                                    updateTextArea("\nNormalizing Pair Data...  Using Options: Robust, C = " + level, fout);
                                    for (int n = 0; n < pairInfo.length; n ++){
                                       updateTextArea("\tCHIP_ID " + pairInfo[n][0], fout);
                                       PairDataReader pdr = new PairDataReader((int[][]) GCTables.get(pairInfo[n][3]));
                                       String rawfile = datapath + File.separator + PREFIX + pairInfo[n][0] + "_raw.txt" ;
                                       String normfile =  datapath + File.separator + PREFIX + pairInfo[n][0] + "_normalized.txt";
                                       pdr.normalizeData(rawfile, (double) level, true);
                                       pdr.outputNormalizedData(rawfile,normfile); 
                                       
                                       array[n]=PairDataReader.readNormalizedData(normfile);
                                       graphInfo[n] = pairInfo[n][0];
                                    }
                                    additionalInfo = "Robust Normalization, C = " + level +" : ";
                                } else{
                                    updateTextArea("\nNormalizing Pair Data...  Using Option: Simple", fout);
                                    for (int n = 0; n < pairInfo.length; n ++){
                                       updateTextArea("\tCHIP_ID" + pairInfo[n][0], fout);
                                       PairDataReader pdr = new PairDataReader((int[][]) GCTables.get(pairInfo[n][3]));
                                       String rawfile = datapath + File.separator + PREFIX + pairInfo[n][0] + "_raw.txt" ;
                                       String normfile =  datapath + File.separator + PREFIX + pairInfo[n][0] + "_normalized.txt";
                                       pdr.normalizeData(rawfile, 2.0, false);
                                       pdr.outputNormalizedData(rawfile,normfile); 
                                       
                                       array[n]=PairDataReader.readNormalizedData(normfile);
                                       //java.util.Arrays.sort(array[n]);
                                       graphInfo[n] = pairInfo[n][0];
                                       additionalInfo = "Simple Normalization : ";
                                    }
                                }
                                GraphManager.showHistograms(array, 1000, graphInfo,additionalInfo,outpath+"MA2C_"+ currentTime+".pdf");
                                //updateTextArea("\nFinding Peaks... ", fout);
                                fout.flush();
                                fout.close();
                               
                            } catch(IOException e){

                            }
                        }
                    }
            
                    
                }   
            };
            loadingThread.start();
        }
        //writeInputFile(seqpath+seqlist +datapath+datalist); 
        // execute c++ using runtime 
        // java.lang.Runtime.getRuntime().exec("/bin/ls");
    }//GEN-LAST:event_runButtonActionPerformed
    /** Check that the chosen IP's are unique **/
    private boolean checkUniqueSamples(int[] sampleRows){
        boolean error = false;
        for (int i =0; i < sampleRows.length-1; i ++){
            for (int j = i+1; j < sampleRows.length; j ++){
                if (((String)sampleKeyTable.getValueAt(sampleRows[i], chipIDindex)).equals(  (String)sampleKeyTable.getValueAt(sampleRows[j], chipIDindex))){
                    updateTextArea("");
                    updateTextArea("Non-unique IP found: CHIP_ID " + (String)sampleKeyTable.getValueAt(sampleRows[i], chipIDindex));
                    error = true;
                }
            }
        }
        return error;
    }
    
    // map_fn = location of tpmap file
    // ratios_fns = locations of normalized data
    // outfile = combined CHIP_IDs without directory path
    private void findPeaks(String map_fn, String[] ratio_fns, String outfile, String PQM, int bandWidth, int maxGap, int minProbe,
            double threshold,String ScoreMethod){

        String outpath = sampleFile.getParent() + File.separator;
        
        /**  Create a new directory called MA2C for output **/
        File outdir = new File(outpath+"MA2C_Output");
        if( !outdir.exists()) {
            boolean dirCreated = outdir.mkdir();
            if (! dirCreated){
                updateTextArea("*** ERROR: FAILED TO CREATE "+ outpath+"MA2C_Output");
                return;
            } else outpath = outpath+"MA2C_Output"+ File.separator;
        } else if (outdir.isDirectory()) outpath = outpath+"MA2C_Output"+ File.separator;
        
        
        RunPeak e =new RunPeak(map_fn,ratio_fns);
        /************Running Model*******************/
        e.SetName(outfile);
        e.set_band_length(bandWidth, maxGap, minProbe);
        updateTextArea("   Building MA2Cscores ...");
        e.Run(ScoreMethod);
        //updateTextArea(outpath+outfile);
        /********************************************/
        updateTextArea("   Calling Peaks...");
        e.CallPeaks(PQM, threshold);
        updateTextArea("   Number of excluded probe = "+e.getNExcluded());
        /* FDR table is generating during calling peaks */
        /******************Print the FDR table***********/
        String fdrtable= outpath+outfile+"_FDRtable.txt" ; //tag.getTag("FDRtable");

        e.FDRTablePrint(fdrtable);
        e.draw_histograms(outpath+outfile+".pdf", outfile);
        /*************************************************/
        /*****************Print the Peaks*****************/
        String outxlsfn=outfile+".xls";
        try{
            updateTextArea("   Writing output...");
            String scorebar=outpath+outfile+".MA2Cscore.bar";
            String ratiobar=outpath+outfile+".ratio.bar";
            e.save_to_barfile(scorebar,"MA2Cscore");
            e.save_to_barfile(ratiobar,"RatioMedian");
            FileWriter out = new FileWriter(outpath+outfile+".bed");
            FileWriter outxls = new FileWriter(outpath+outxlsfn);
            FileWriter negoutxls=new FileWriter(outpath+outfile+"_neg.xls");
            FileWriter gffout = new FileWriter(outpath+outfile+".gff");
             e.BedPrinter(out);//print the bed file of positive peaks;
             e.BedXlsPrinter(outxls);//print the positive peaks;
             e.BedXlsPrinter(negoutxls,-1);//print the negative peaks;
             e.GFFPrinter(gffout,outfile);
            out.close();
            outxls.close();
            negoutxls.close();
            gffout.close();
            } catch (IOException ex)
            {
               System.err.println("error in"+ ex);
            }

        updateTextArea("Finished "+outfile+"\n");   
    }
    
    /** Get all CHIP_ID in SampleKey.txt **/
    private Vector<String[]> getAllCHIP_ID(){
        Vector uniqueCHIP_ID = new Vector();
        int R = sampleKeyTable.getRowCount();
        for (int i = 0; i < R; i ++){
            int L = uniqueCHIP_ID.size();
            String[] tmp = new String[2];
            tmp[0] = (String) sampleKeyTable.getValueAt(i, chipIDindex);
            tmp[1] = (String) sampleKeyTable.getValueAt(i, designIDindex);
            boolean firstTime = true;
            for (int j = 0; j < L; j ++){
                if ( ((String[]) uniqueCHIP_ID.elementAt(j))[0].equals(tmp[0])){
                    firstTime = false;
                    break;
                }
            }
            if (firstTime) {
                //String[] info = new String[]{tmpChIPID, tmpDesignID};
                uniqueCHIP_ID.add(tmp);
            }
        }
        return uniqueCHIP_ID;
    }
    
    private String[] getChosenChIPIDs(int[] sampleRows){
        /** Check that the chosen IP's have corresponding .ndf files **/
        String[] CHIP_IDlist = new String[sampleRows.length]; 
        for (int i = 0; i < sampleRows.length; i ++){
            CHIP_IDlist[i] = (String) sampleKeyTable.getValueAt( sampleRows[i], chipIDindex);
            
        }
        return CHIP_IDlist;
    }
    /** For each selected sample, check that there is a corresponding sequence file **/
    private Vector<String[]> checkSeqFiles(int[] sampleRows){
        Hashtable ht = new Hashtable();
        Vector fileinfo = new Vector();  // vector containing information of Sequence, IP, Input files
        boolean error = false;
        String[] tpmaplist = seqDir.list();
        Hashtable tp = new Hashtable();  // table of DESIGN_ID to .tpmap file 
        
        /** Read the DESIGN_ID of all .ndf files **/
        for (int i = 0; i < seqFileTable.getRowCount(); i ++){
            String filename = (String ) seqFileTable.getValueAt(i,0);
            String designID="";
            filename = seqDir.getAbsolutePath()+File.separator+filename.trim();
            try{
                int thisdesignIDIndex=-1;
                BufferedReader f = new BufferedReader (new FileReader(filename));
                String line;
                        
                while ( (line =f.readLine())!= null) {
                    if (line.trim().indexOf("#") == 0) continue;
                    else{
                        
                        String[] header = line.split("\t");
                        for (int j = 0; j < header.length; j ++){
                             if (header[j].trim().equals("DESIGN_ID")) thisdesignIDIndex = j;
                        } 
                        break;
                    }
                }
                if (thisdesignIDIndex == -1 ) continue;
                designID = f.readLine().split("\t")[thisdesignIDIndex].trim();
                ht.put(designID,filename);
                f.close();
            } catch (IOException io){
                System.err.print("Cannot open " + filename );
                updateTextArea("Cannot open " + filename); 
            }
            //updateTextArea2(designID);
        }
        
        /** Check that the chosen IP's have corresponding .ndf files **/
        for (int i = 0; i < sampleRows.length; i ++){
            String sampleDesignID = (String) sampleKeyTable.getValueAt( sampleRows[i], designIDindex);
            String[] f = new String[5];
            for(int j=0; j < tpmaplist.length; j++){
                String lookfor = "MA2C_"+sampleDesignID+".tpmap";
                if (tpmaplist[j].equals(lookfor)) tp.put(sampleDesignID, lookfor);  // check if the corresponding .tpmap file exists
            }
            if (ht.containsKey(sampleDesignID) || tp.containsKey(sampleDesignID)){
                f[0] = (String) sampleKeyTable.getValueAt(sampleRows[i], chipIDindex);
                f[1] = (String) sampleKeyTable.getValueAt(sampleRows[i], dyeIndex);
                f[2] = (String) sampleDesignID;
                fileinfo.add(f);
            } else{
                error = true;
                updateTextArea("\n*** ERROR\nSequence file not found for CHIP_ID " + (String) sampleKeyTable.getValueAt(sampleRows[i], chipIDindex));
            }
            
        }
        if (error){
            return new Vector();
        }
        updateTextArea("\nSEQUENCE FILES");
        for (int i = 0; i < fileinfo.size(); i ++){
            String[] tmp = (String[]) fileinfo.elementAt(i);
            updateTextArea("  CHIP_ID "+tmp[0]+ " " +  tmp[1]+": "+ (String)ht.get(tmp[2]));
        }
        return fileinfo;
    }
    
    /** For each selected sample, check that there are corresponding pair data files **/
    /** Returns true if all pair data files are found **/
    private boolean checkPairDataFiles(Vector fileinfo){
        Hashtable ht = new Hashtable();
        boolean error = false;
        /** Read the CHIP_ID of all pair data files **/
        for (int i = 0; i < pairDataTable.getRowCount(); i ++){
            String filename = (String ) pairDataTable.getValueAt(i,0);
            String imageID="";
            filename = dataDir.getAbsolutePath()+File.separator+filename.trim();
            try{
                int imageIDIndex = -1;
                BufferedReader f = new BufferedReader (new FileReader(filename));
                String line;
                        
                while ( (line =f.readLine())!= null) {
                    if (line.trim().indexOf("#") == 0) continue;
                    else{
                        
                        String[] header = line.split("\t");
                        for (int j = 0; j < header.length; j ++){
                             if (header[j].trim().equals("IMAGE_ID")) imageIDIndex = j;
                        } 
                        break;
                    }
                }
                if (imageIDIndex == -1) continue;
                imageID = f.readLine().split("\t")[imageIDIndex].trim();
                ht.put(imageID,filename);
                f.close();
            } catch (IOException io){
                System.err.print("Cannot open " + filename );
                updateTextArea("Cannot open " + filename); 
            }
            //updateTextArea2(designID);
        }
        
        /** Check that the chosen IP's have corresponding .ndf files **/
        for (int i = 0; i < fileinfo.size(); i ++){
            String[] info = (String[]) fileinfo.elementAt(i);
            String sampleChipID = info[0];
            String dye = info[1].toUpperCase();
            String IPFile="";
            String inputFile = "";
            
            // Determine which dye is IP and which dye is input
            if (dye.equals("CY3")) {
                IPFile = sampleChipID + "_532";
                inputFile = sampleChipID +"_635";
            } else{
                IPFile = sampleChipID + "_635";
                inputFile = sampleChipID +"_532";
            }
           
            if (ht.containsKey(IPFile) && ht.containsKey(inputFile)){
                info[3] = (String) ht.get(IPFile);
                info[4] = (String) ht.get(inputFile);
            } else{
                error = true;
                String checkRawData = "MA2C_"+sampleChipID+"_raw.txt";
                for (int j = 0; j < pairDataTable.getRowCount(); j ++){
                    String filename = (String ) pairDataTable.getValueAt(j,0);
                    if (filename.equals(checkRawData)) error = false;
                }
                
                if (error) updateTextArea("\n*** ERROR\nData file(s) not found for CHIP_ID " + sampleChipID);
            }
            
        }
        if (error){
            return false;
        }
        updateTextArea("\nPAIR DATA FILES");
        for (int i = 0; i < fileinfo.size(); i ++){
            String[] tmp = (String[]) fileinfo.elementAt(i);
            updateTextArea("  CHIP_ID "+tmp[0]+ " IP : "+ tmp[3]);
            updateTextArea("  CHIP_ID "+tmp[0]+ " Input : " + tmp[4]);
        }
        return true;
    }
    
    private void readSequences(Vector fileinfo){
        updateTextArea("\nREADING SEQUENCE FILES");
        Hashtable seqlist = new Hashtable();  // list of distinct sequence files
        Vector sequenceArrays = new Vector();
        int count = 0;                        // index of sequence files in the unique list seqlist
        for(int i = 0; i < fileinfo.size(); i ++){
            String[] info = (String[]) fileinfo.elementAt(i);
            String seqFile = info[2];
            if(!seqlist.containsKey(seqFile)) {
                seqlist.put(seqFile, count);
                count ++;
            }
        }
        for (Enumeration e = seqlist.keys() ; e.hasMoreElements() ;) {
            String seqfilename = (String)e.nextElement();
            updateTextArea("  " + seqfilename);
            GC_Enumerator GC = new GC_Enumerator(seqfilename);
            sequenceArrays.add(GC.seqTable);
        }
        updateTextArea("... Finished reading sequence files");
    }
    
    
    private String readTable(int[] rows, TableModel tm, int column){
        String selectedRows = (String) tm.getValueAt(rows[0], column);
        for(int i =1; i < rows.length; i++){
            selectedRows += "\t"+(String) tm.getValueAt(rows[i],column) ;
        }
        selectedRows += "\n";
        return selectedRows;
    }
    
    // When the Run Button is pressed, generate an input file for c++ analysis.
    private void writeInputFile(String info){
        String outpath = configpath +File.separator+"LOG_FILES"+File.separator+"SMAT_"+UtilityFunctions.getCurrentTime()+".txt";
        try{
            FileWriter fo = new FileWriter(new File(outpath));
            fo.write(info);
            fo.flush();
            fo.close();
        } catch (IOException io){
            updateTextArea("CANNOT OPEN FILE:"+outpath);
            System.err.print("Cannot open file:"+outpath);
        }
    }
    private void pairDataButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pairDataButtonActionPerformed
        if (sampleFile == null){
            updateTextArea("Please select a SampleKey file first.");
            return;
        }
        getPairDataDir();
        jTabbedPane1.setEnabledAt(1, true);
        jTabbedPane1.setEnabledAt(2, true);
    }//GEN-LAST:event_pairDataButtonActionPerformed

// Determine which sequence file to read
    private void seqFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_seqFileButtonActionPerformed
        if (sampleFile == null){
            updateTextArea("Please select a SampleKey file first.");
            return;
        }
        getSequenceDir();
        
    }//GEN-LAST:event_seqFileButtonActionPerformed

// Read SampleKey.txt and retrieve the Input/Experiment information
    private void sampleKeyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sampleKeyButtonActionPerformed
        getSampleKey();
    }//GEN-LAST:event_sampleKeyButtonActionPerformed

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitButtonActionPerformed
    
    
    
    private Vector<String[]> parseSampleKeys(String filename){
        Vector<String[]> lines = new Vector<String[]>();
        String line = null;
        try{
            BufferedReader f = new BufferedReader (new FileReader(filename));
            while((line=f.readLine())!= null){
                if (line.trim().equals("")) continue;
                String[] columns = line.split("\t");
                for (int i=0; i< columns.length; i ++){
                    columns[i] = columns[i].trim();
                }
                lines.add(columns);
            }
        } catch (IOException io){
           
        }
        return lines;
    }
    
    
    
    private void setColumnWidths(Vector<String[]> lines, javax.swing.JTable T, int nCol){
        int[] maxWid = new int [nCol];
        int nRows = lines.size();
        // Find maximum width of each column
        for (int i =0; i < nRows; i++){
            String[] entry =(String[]) lines.elementAt(i);
            for (int j=0; j < nCol; j ++){
                if (maxWid[j] < entry[j].length()) maxWid[j] = entry[j].length(); 
            }
        }
        
        for (int j=0; j < nCol; j ++){
            javax.swing.table.TableColumn col = T.getColumnModel().getColumn(j);
            col.setPreferredWidth(maxWid[j]*9+5);
        }
    }
    
    private void getColIndices(String[] header){
        chipIDindex = -1;
        designIDindex = -1;
        dyeIndex = -1;
        for ( int i =0; i < header.length ; i ++){
            if( header[i].toUpperCase().equals("CHIP_ID")) chipIDindex = i;
            else if (header[i].toUpperCase().equals("DESIGN_ID")) designIDindex = i;
            else if (header[i].toUpperCase().equals("DYE")) dyeIndex = i;
        }
    }
    
    // If SampleKey.txt, seq dir and pair data dir are found, then enable tabs
    private void enableTabs(){
        jTabbedPane1.setEnabledAt(1, true);
        jTabbedPane1.setEnabledAt(2, true);
    }
    private void getSampleKey(){
        String absPath;
        Object[][] tablecontent;
        FileFilter fileFilter = new FileFilter() {
            public boolean accept(File file) {
                return file.toString().endsWith(".txt") || file.isDirectory();
            }
            public String getDescription(){
                return ".txt";
            }
        };
        jFileChooser1.setFileFilter(fileFilter);
        if (previousDir != null && new File(previousDir).exists()) jFileChooser1.setCurrentDirectory(new File(previousDir));
        
        int result = jFileChooser1.showOpenDialog(this.getParent());
        switch (result) {
            case javax.swing.JFileChooser.APPROVE_OPTION:
                sampleFile = jFileChooser1.getSelectedFile();
                absPath = sampleFile.getAbsolutePath();
                Vector<String[]> lines = (Vector<String[]>) parseSampleKeys(absPath);
                String[] header =(String[]) lines.elementAt(0);
                
                /** get CHIP_ID and DESIGN_ID column indices **/
                getColIndices(header);
                if (chipIDindex == -1 || designIDindex == -1 || dyeIndex == -1){
                    if (chipIDindex == -1) updateTextArea("ERROR: CHIP_ID column not found.");
                    if (designIDindex == -1) updateTextArea("ERROR: DESIGN_ID column not found.");
                    if (dyeIndex == -1) updateTextArea("ERROR: DYE column not found.");
                    return;
                }
                final int colN = header.length;
                int rowN = lines.size();
                tablecontent = new Object[rowN-1][colN];
                for (int i = 1; i < rowN; i ++){
                    String [] line = (String[]) lines.elementAt(i);
                    for (int j =0; j < colN; j++){
                        tablecontent[i-1][j] = line[j];
                    }
                }
                sampleKeyTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
                header){
                    boolean[] canEdit = new boolean[colN];
                    public boolean isCellEditable(int rowIndex, int columnIndex) {
                        return canEdit [columnIndex];
                    }                
                });
                setColumnWidths(lines,sampleKeyTable, colN);
                previousDir = sampleFile.getParent();
                updateTextArea("SampleKey:"+"\t\t"+absPath);
                
                allChIPDesignID = getAllCHIP_ID();
                sampleKeyFound = true;
            break;
        case javax.swing.JFileChooser.CANCEL_OPTION:
            return;
        case javax.swing.JFileChooser.ERROR_OPTION:
            // The selection process did not complete successfully
            break;
        }
        if (checkDir(previousDir,"seq")) {
            getSequenceDir(previousDir+File.separator+"DesignFiles");
            updateTextArea2("- Please verify the DesignFile directory.");
            seqDirFound = true;
        } else{
            updateTextArea2("- COULD NOT LOCATE the DesignFile directory.");
            updateTextArea2("  Please select the DesignFile directory.");
        }
        if (checkDir(previousDir,"pair")) {
            getPairDataDir(previousDir+File.separator+"PairData");
            updateTextArea2("- Please verify the PairData directory.");
            updateTextArea2("  ** The file extension of data files should be .txt.");
            pairDirFound = true;
        } else{
            updateTextArea2("- COULD NOT LOCATE the PairData directory.");
            updateTextArea2("  Please select the PairData directory.");
            updateTextArea2("  ** The file extension of data files should be .txt.");
        }
        if (sampleKeyFound == true && seqDirFound == true && pairDirFound == true) enableTabs();
    }
    
    /** Check whether DesignFiles and PairData Folders exists in the same directory as SampleKey **/
    private boolean checkDir(String path, String seqOrPair){
        boolean DirFound = false;
        File f = new File(path);
        File[] files = f.listFiles();
        if (seqOrPair =="seq"){
            for (int i =0; i < files.length; i ++){
                if (files[i].isDirectory() && files[i].getName().indexOf("DesignFiles") >=0)
                    return true;
            }
        } else if ( seqOrPair =="pair") {
            for (int i =0; i < files.length; i ++){
                if (files[i].isDirectory() && files[i].getName().indexOf("PairData") >=0)
                    return true;
            }
        }
        return DirFound;
    }
    
    
    private void getSequenceDir(String path){
        seqDir = new File(path);
        //File f = new File(path);
        String[] files;
        Object[][] tablecontent;
        
        FilenameFilter filter = new FilenameFilter() {
            public boolean accept(File dir, String name) {
                return name.endsWith(".ndf") ||  name.endsWith(".tpmap");
            }
        }; 
        files = seqDir.list(filter);
        
        updateTextArea("Design File Directory:"+"\t"+path);
        
        int nFiles = files.length;
        tablecontent = new Object[nFiles][1];
        for (int i = 0; i < files.length;i++) tablecontent[i][0]= files[i];
        seqFileTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
        new String [] {"Sequence File"}){
            boolean[] canEdit = new boolean[1];
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }                
        });

    }
    
    private void getSequenceDir(){
        String absPath;
        String files[];
        Object[][] tablecontent;
        int nFiles;
        jFileChooser2.setCurrentDirectory(new File(previousDir));
        int result = jFileChooser2.showOpenDialog(this.getParent());
        FilenameFilter filter = new FilenameFilter() {
            public boolean accept(File dir, String name) {
            return name.endsWith(".ndf");
        }
        }; 
        // Determine which button was clicked to close the dialog
        switch (result) {
            case javax.swing.JFileChooser.APPROVE_OPTION:
                seqDir = jFileChooser2.getSelectedFile();
                files = seqDir.list(filter);
                absPath = seqDir.getAbsolutePath();
                previousDir = seqDir.getParent();
                updateTextArea("Design File Directory:"+ "\t"+absPath);
                nFiles = files.length;
                tablecontent = new Object[nFiles][1];
                for (int i = 0; i < files.length;i++) tablecontent[i][0]= files[i];
                seqFileTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
                new String [] {"Sequence File"}){
                    boolean[] canEdit = new boolean[1];
                    public boolean isCellEditable(int rowIndex, int columnIndex) {
                        return canEdit [columnIndex];
                    }                
                });
            seqDirFound = true;
            break;
        case javax.swing.JFileChooser.CANCEL_OPTION:
            return;
        case javax.swing.JFileChooser.ERROR_OPTION:
            // The selection process did not complete successfully
            break;
        }
    }
    
    
     private void getPairDataDir(String path){
        dataDir = new File(path);
        //File f = new File(path);
        String[] files;
        Object[][] tablecontent;
        
        FilenameFilter filter = new FilenameFilter() {
            public boolean accept(File dir, String name) {
                return name.endsWith(".txt") || name.endsWith(".pair");
            }
        }; 
        files = dataDir.list(filter);
        updateTextArea("Pair Data Directory:"+"\t"+path);
        int nFiles = files.length;
        tablecontent = new Object[nFiles][1];
        for (int i = 0; i < files.length;i++) tablecontent[i][0]= files[i];
        pairDataTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
        new String [] {"Pair Data Files"}){
            boolean[] canEdit = new boolean[1];
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }                
        });

    }
    
    private void getPairDataDir(){
        String absPath;
        String files[];
 
        jFileChooser3.setCurrentDirectory(new File(previousDir));
        int result = jFileChooser3.showOpenDialog(this.getParent());
        Object[][] tablecontent;
        // Determine which button was clicked to close the dialog
        switch (result) {
            case javax.swing.JFileChooser.APPROVE_OPTION:
                dataDir = jFileChooser3.getSelectedFile();
                files = dataDir.list();
                absPath = dataDir.getAbsolutePath();
                previousDir = dataDir.getParent();
                updateTextArea("Pair Data Directory:"+"\t"+absPath);
                tablecontent = new Object[files.length][1];
                for (int i = 0; i < files.length;i++) tablecontent[i][0]= files[i];
                pairDataTable.setModel(new javax.swing.table.DefaultTableModel( tablecontent, 
                new String [] {"Pair Data Files"}){
                    boolean[] canEdit = new boolean[1];
                    public boolean isCellEditable(int rowIndex, int columnIndex) {
                        return canEdit [columnIndex];
                    }                
                });
            pairDirFound= true;
            break;
        case javax.swing.JFileChooser.CANCEL_OPTION:
            return;
        case javax.swing.JFileChooser.ERROR_OPTION:
            // The selection process did not complete successfully
            break;
        }
        
    }
    
    /**
     * @param args the command line arguments
     */
    
   
    private void updateTextArea(String a){
        jTextArea1.append(a+"\n");
        jTextArea1.setCaretPosition( jTextArea1.getDocument().getLength() );
    }
    
    private void updateTextArea2(String a){
        jTextArea2.append(a+"\n");
        jTextArea2.setCaretPosition( jTextArea2.getDocument().getLength() );
    }
    private void updateTextArea(String a, FileWriter fw){
        jTextArea1.append(a+"\n");
        try{
            fw.write(a+"\n");
            fw.flush();
        } catch(IOException e){
            System.err.print("Cannot write to a log file.");
        }
        jTextArea1.setCaretPosition( jTextArea1.getDocument().getLength() );
    }
    
    private void updateTextArea2(String a, FileWriter fw){
        jTextArea2.append(a+"\n");
        jTextArea2.setCaretPosition( jTextArea2.getDocument().getLength() );
    }
  
    public static void main(String args[]) {
        //java.awt.EventQueue.invokeLater(new Runnable() {
            //public void run() {
            // new ControlPanel().setVisible(true);
            //}     
            
            System.out.println(UtilityFunctions.getCurrentTime());
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField bandwidthTextField;
    private javax.swing.JButton exitButton;
    private javax.swing.JComboBox jBoxMA2CScore;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JFileChooser jFileChooser2;
    private javax.swing.JFileChooser jFileChooser3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTextArea jTextArea5;
    private javax.swing.JTextField maxGapTextField;
    private javax.swing.JTextField minProbeTextField;
    private javax.swing.JTextField outFileTextField;
    private javax.swing.JButton pairDataButton;
    private javax.swing.JTable pairDataTable;
    private javax.swing.JButton peakFinderButton;
    private javax.swing.JTable replicateTable;
    private javax.swing.JButton runButton;
    private javax.swing.JButton sampleKeyButton;
    private javax.swing.JTable sampleKeyTable;
    private javax.swing.JButton seqFileButton;
    private javax.swing.JTable seqFileTable;
    private javax.swing.JTextField thresholdTextField;
    // End of variables declaration//GEN-END:variables
    
}
